<?php
$taxonomy           = $profile['author_attributes'];
$mapping_type       = (isset($profile['mapping_type']) && !empty($profile['mapping_type'])) ? $profile['mapping_type'] : self::$default_profile['api_key']['mapping_type'];
$story_post_mapping = (isset($profile['story_post_mapping']) && !empty($profile['story_post_mapping'])) ? $profile['story_post_mapping'] : self::$default_profile['api_key']['story_post_mapping'];
$exlude_posttypes   = array('attachment','revision','nav_menu_item','acf','acf-field-group','acf-field','nf_sub');

$args = array(
    'public'   => true,
    '_builtin' => false
);
$post_types = get_post_types($args);
$post_types += get_post_types();

?>

<div class="width100 js-profile-form">
    <input type="hidden" name="action" value="set_profile_post_type_mapping">
    <input type="hidden" name="api_key" value="<?php echo esc_html($api_key);?>">
    <div class="cl_inside">
        <div>
            <input type="radio" <?php if($mapping_type == 'all') { ?> checked="checked" <?php } ?> class="selbox" id="single" name="mapping_type" value="all" /><label for="single" style="vertical-align: 1px;"><?php echo esc_html_e('Map all Contently story types to one specific Wordpress post type', 'contently') ?></label><br />
        </div>
        <div style="clear:both;">&nbsp;</div>
        <div>
            <input type="radio" <?php if($mapping_type == 'individual') { ?> checked="checked" <?php } ?>  class="selbox" id="double" name="mapping_type" value="individual"/><label for="double" style="vertical-align: 1px;"> <?php echo esc_html_e('Map individual types', 'contently') ?></label><br />
        </div>
        <hr>
        <div class="single_box cl_allboxes" <?php if($mapping_type != 'all') { ?> style="display:none;" <?php } ?>>
            <div class="cl-row">
                <div class="cl-col-3">
                    <strong><?php echo esc_html_e('Post type', 'contently') ?></strong>
                </div>
                <div class="cl-col-3">
                    <strong><?php echo _e('Post template', 'contently') ?></strong>
                </div>
                <div class="cl-col-4">
                    <strong><?php echo esc_html_e('Contently story type', 'contently') ?></strong>
                </div>
                <div class="cl-col-2">
                    <strong><?php echo esc_html_e('Action', 'contently') ?></strong>
                </div>
            </div>
            <div class="cl-row">
                <div class="cl-col-3">
                    <select name="story_post_mapping[all]" class="js-choose-post-type">
                        <option value=""><?php echo esc_html_e('Select post type', 'contently') ?></option>
                        <?php
                        foreach($post_types as $key=>$post_type) {
                            if(!in_array($key, $exlude_posttypes)) {
                                if($story_post_mapping['all']==$key) {
                                    $selected = 'selected="selected"';
                                } else {
                                    $selected = '';
                                }
                                ?>
                                <option value="<?php echo esc_html($key); ?>" <?php echo esc_html($selected); ?>><?php echo esc_html($key); ?></option>
                                <?php
                            }
                        }
                        ?>
                    </select>
                </div>
                <div class="cl-col-3">
                    <?php $custom_template_support = version_compare( $GLOBALS['wp_version'], '4.7', '<') && $story_post_mapping['all'] !== 'page'; ?>
                    <span id="custom_template_error" style="display: <?php echo $custom_template_support ? 'block' : 'none'; ?>">
                        <?php echo _e('Your WP version support custom templates only for page post type.', 'contently') ?>
                    </span>
                    <select name="story_post_mapping[post_template]" id="js_choise_post_template" style="width: 85%; display: <?php echo $custom_template_support ? 'none' : 'block'; ?>">
                        <option value="default"><?php echo _e('Default Template', 'contently') ?></option>
                        <?php
                            foreach(get_page_templates(null, $story_post_mapping['all']) as $post_template => $path) {
                                if(!empty($story_post_mapping['post_template']) && $story_post_mapping['post_template'] == $post_template) {
                                    $selected = 'selected="selected"';
                                } else {
                                    $selected = '';
                                }
                                ?>
                                <option value="<?php echo $post_template; ?>" <?php echo $selected; ?>><?php echo $post_template; ?></option>
                            <?php
                            }
                        ?>
                    </select>
                </div>
                <div class="cl-col-4">
                    <?php echo esc_html_e('All Types', 'contently') ?>
                </div>
                <div class="cl-col-2">
                    <?php
                    if(! empty($story_post_mapping['all'])) { ?>
                        <a class="js-ajax-redirect"
                           data-type="<?php echo $story_post_mapping['all']; ?>"
                           data-post-template="<?php echo $story_post_mapping['post_template']; ?>"
                           data-action="get_profile_configure_mapping"
                        >
                            <?php echo esc_html_e('Configure mapping', 'contently') ?>
                        </a>
                    <?php } else {
                        echo esc_html("Please Update Wordpress Post to Configure mapping");
                    }?>
                </div>
            </div>
        </div>

        <div class="double_box cl_allboxes" <?php if($mapping_type != 'individual') { ?> style="display:none;" <?php } ?> >

            <div class="cl-row">
                <div class="cl-col-2">
                    <strong><?php echo esc_html_e('Post type', 'contently') ?></strong>
                </div>
                <div class="cl-col-5">
                    <strong><?php echo esc_html_e('Contently story type', 'contently') ?></strong>
                </div>
                <div class="cl-col-3">
                    <strong><?php echo esc_html_e('Action', 'contently') ?></strong>
                </div>
            </div>
            <?php

            foreach($post_types as $key=>$post_type) {
                if(!in_array($key, $exlude_posttypes)) {
                    ?>
                    <div class="cl-row">
                        <div class="cl-col-2">
                            <?php echo esc_html($key); ?>
                        </div>
                        <div  class="cl-col-5"><select name="story_post_mapping[<?php echo esc_html($key); ?>]">
                                <option value=""><?php echo esc_html_e('select', 'contently') ?></option>

                                <?php foreach($taxonomy['story_formats'] as $story_format){
                                    if(!empty($story_post_mapping[$key]) && $story_post_mapping[$key]==$story_format) {
                                        $selected = 'selected="selected"';
                                    } else {
                                        $selected = '';
                                    }
                                    ?>
                                    <option value="<?php echo esc_html($story_format); ?>" <?php echo esc_html($selected); ?>><?php echo esc_html($story_format); ?></option>
                                <?php } ?>
                            </select>
                        </div>
                        <div class="cl-col-3">
                            <?php if(!empty($story_post_mapping[$key])){ ?>
                                <a class="js-ajax-redirect" data-type="<?php echo esc_html($key); ?>" data-action="get_profile_configure_mapping"><?php echo esc_html_e('Configure mapping', 'contently') ?></a>
                            <?php } else { echo esc_html_e("Please update Wordpress post type to configure mapping", 'contently'); } ?>
                        </div>
                    </div>
                    <?php
                }
            } ?>
        </div>
    </div>
</div>